// Objects.ch ver 2.0 b         << Beta release >>  For size and speedddddddd
// (C) Antonio Linares, 1993

// If you are interested in Objects, you can get the commercial version.
// Available is version 1.5. It includes full source code, a lot of OOPS
// Classes and Tools, and the ability to inherit from Clipper standard
// Classes, and a full and complete OOPS technical documentation.

// To get full complete version 1.5 -30 US$-, please contact by mail:

// SOFT>MAIL
// Muntaner 44
// 08011 Barcelona - SPAIN
// A/A J. Urbea

// This beta release is for those interested in speed and size! It does not
// includes sources, documentation, Classes and tools. You should get version
// 1.5.
// Please report me your impressions, and let me know if you are interested
// in receiving the 2.0 commercial release.

// mail address:

// Antonio Linares
// Avd. R. Soriano 68, 1-7
// 29600 Marbella - SPAIN

// Fido: 2:345/201.21
// CIS: 100114, 1776

// Major changes from version 1.5:

// Much more speed and incredible small size !!!  Try it !!!
// No public exported symbols --> Much less EXE size !!!
// You should use Super:...( ... ) instead of ::Parent
// It coexists with other non Object-Classes
// You have to recompile your previous Objects 1.2 & 1.5 Classes

// IMPORTANT: You should use FREE Objects 2.0 beta as your OOPS kernel
// for your libraries and commercial products. You just have to mention
// on your DOC: you are using Objects 2.0 OOPS engine.

//----------------------------------------------------------------------------//

#ifndef _OBJECTS_CH
#define _OBJECTS_CH

#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  <uVar1> := If( <uVar1> == nil, <uVal1>, <uVar1> ) ;;
                [ <uVarN> := If( <uVarN> == nil, <uValN>, <uVarN> ); ]

#xcommand CLASS <ClassName> ;
             [ <from: INHERIT FROM, FROM, OF> <Parent1> [ ,<ParentN> ] ] ;
          => ;
          function <ClassName>() ;;
             static nClassHandle ;;
                if nClassHandle == nil ;;
                   ClsNew( <"ClassName">, { [ <Parent1>():ClassH ] ;
                                            [,<ParentN>():ClassH } ] } ) ;;
                   #define _PARENT <Parent1>():ClassH

#xcommand DATA <Data1> [,<DataN>] => ;
            ClsAddData( <"Data1">, 0 ) [; ClsAddData( <"DataN">, 0 ) ]

#xcommand VAR <Data1> [,<DataN>] => ;
            ClsAddData( <"Data1">, 0 ) [; ClsAddData( <"DataN">, 0 ) ]

#xcommand DATA <Data> READONLY => ClsAddData( <"Data">, 1 )

#xcommand DATA <Data> HIDDEN => ClsAddData( <"Data">, 1 )

#xcommand METHOD <MethodName>( [<uParms,...>] ) CONSTRUCTOR => ;
            ClsAddMethod( <"MethodName">, ;
            { | Self [, <uParms> ] | <MethodName>( Self [, <uParms> ] ), Self } )

#xcommand METHOD <MethodName>( [<uParms,...>] ) => ;
            ClsAddMethod( <"MethodName">, ;
            { | Self [, <uParms> ] | <MethodName>( Self [, <uParms> ] ) } )

#xcommand METHOD <MethodName>( [<uParms,...>] ) VIRTUAL => ;
            ClsAddMethod( <"MethodName">, { || nil } )

#xcommand METHOD <MethodName>( [<uParms,...>] ) SETGET => ;
            ClsAddMethod( <"MethodName">,;
                { | Self [,<uParms>] | <MethodName>( Self [,<uParms>] ) } ) ;;
            ClsAddMethod( "_" + <"MethodName">,;
                { | Self [,<uParms>] | <MethodName>( Self [,<uParms>] ) } )

#xcommand METHOD <MethodName>( [<uParms,...>] ) ;
          <inline: BLOCK, INLINE> <bCodeBlock> => ;
          ClsAddMethod( <"MethodName">, <bCodeBlock> )

#xcommand ENDCLASS => ;
                nClassHandle = nClsMake() ;;
             end ;;
          return __ClassIns( nClassHandle )

#xtranslate :: => Self:


//------ METHODS Sintax -----------

// C++ style
#xtranslate METHOD <ClassName>::<MethodName>( [<uParms,...>] ) => ;
         static function <MethodName>( Self [, <uParms>] ) // CLASS <ClassName>

// ASPEN style
#xtranslate METHOD <MethodName>( [<uParms,...>] ) CLASS <ClassName> => ;
         static function <MethodName>( Self [, <uParms>] ) // CLASS <ClassName>

#xtranslate FUNCTION <ClassName>.<MethodName>( [<uParms,...>] ) => ;
         static function <MethodName>( Self [, <uParms>] ) // CLASS <ClassName>

//---------------------------------

#xtranslate Super:<Method>( [<uParms,...>] ) => ;
       Super( _PARENT, <"Method">, Self [,<uParms>] )
       // Eval( bClsMethod( _PARENT, <"Method"> ), Self [,<uParms>] )

// #xtranslate Self:Parent( <cParentName> ):<Method>( [<uParms,...>] ) => ;
//       Eval( bClsMethod( <"cParentName">, <"Method"> ) ), Self [,<uParms>] )

#endif

//----------------------------------------------------------------------------//
